using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;

namespace AppliedDataBindingSample {

  [TypeConverter(typeof(PositionsConverter))]
  public class Positions: INotifyPropertyChanged {

    #region INotifyPropertyChanged Members

    public event PropertyChangedEventHandler PropertyChanged;

    private void OnPropertyChanged(string propertyName) {
      if( this.PropertyChanged != null ) {
        this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
      }
    }
    
    #endregion
    
    private int firsts;
    private int seconds;
    private int thirds;

    public Positions() { }
    public Positions(int firsts, int seconds, int thirds) {
      this.firsts = firsts;
      this.seconds = seconds;
      this.thirds = thirds;
    }

    public int Firsts {
      get { return this.firsts; }
      set { this.firsts = value; this.OnPropertyChanged("Firsts"); }
    }

    public int Seconds {
      get { return this.seconds; }
      set { this.seconds = value; this.OnPropertyChanged("Seconds"); }
    }

    public int Thirds {
      get { return this.thirds; }
      set { this.thirds = value; this.OnPropertyChanged("Thirds"); }
    }

    //public override string ToString() {
    //  return string.Format("{0}-{1}-{2}", this.firsts, this.seconds, this.thirds);
    //}
  }
}
