using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;

namespace AppliedDataBindingSample {

  public class RaceCarDrivers : BindingList<RaceCarDriver>, IComponent {

    #region IComponent Members

    ISite site = null;

    [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
    [Browsable(false)]
    public ISite Site {
      get { return site; }
      set { site = value; }
    }

    public event EventHandler Disposed;

    #endregion

    #region IDisposable
    bool disposed;

    public void Dispose() {
      Dispose(true);
      GC.SuppressFinalize(this);
    }

    protected virtual void Dispose(bool disposing) {
      if( !disposed ) {
        if( !this.disposed ) {
          this.disposed = true;
          if( this.Disposed != null ) this.Disposed(this, EventArgs.Empty);
        }
      }
    }

    ~RaceCarDrivers() {
      Dispose(false);
    }

    #endregion
  }
}
