﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Threading;
using System.Windows.Forms;

namespace SyncCalcPiSample {

  partial class SyncCalcPiForm : Form {

    public SyncCalcPiForm() {
      InitializeComponent();
    }

    void ShowProgress(string pi, int totalDigits, int digitsSoFar) {
      // Display progress in UI
      this.resultsTextBox.Text = pi;
      this.calcToolStripProgressBar.Maximum = totalDigits;
      this.calcToolStripProgressBar.Value = digitsSoFar;

      if( digitsSoFar == totalDigits ) {
        // Reset UI
        this.calcToolStripStatusLabel.Text = "Ready";
        this.calcToolStripProgressBar.Visible = false;
      }

      // Force UI update to reflect calculation progress
      this.Refresh();
    }

    void CalcPi(int digits) {
      StringBuilder pi = new StringBuilder("3", digits + 2);

      // Show progress
      ShowProgress(pi.ToString(), digits, 0);

      if( digits > 0 ) {
        pi.Append(".");

        for( int i = 0; i < digits; i += 9 ) {
          int nineDigits = NineDigitsOfPi.StartingAt(i + 1);
          int digitCount = Math.Min(digits - i, 9);
          string ds = string.Format("{0:D9}", nineDigits);
          pi.Append(ds.Substring(0, digitCount));

          // Show progress
          ShowProgress(pi.ToString(), digits, i + digitCount);
        }
      }

      this.calcToolStripStatusLabel.Text = "Ready";
      this.calcToolStripProgressBar.Visible = false;
    }

    void calcButton_Click(object sender, EventArgs e) {
      // Set calculating UI
      this.calcToolStripProgressBar.Visible = true;
      this.calcToolStripStatusLabel.Text = "Calculating...";

      // Convert up-down control's decimal Value to an integer
      CalcPi((int)this.decimalPlacesNumericUpDown.Value);
    }
  }
}
