using System;
using System.Collections.Generic;
using System.Configuration;
using System.Deployment.Application;
using System.Diagnostics;
using System.Security.Policy;
using System.Text;

namespace Wahoo {
  public static class UrlJiggler {

    public static string JiggleUrl(string url) {
      // Get update location
      Uri updateLocation = UpdateLocation;
      // Bail if not launched via ClickOnce
      if( updateLocation == null ) return url;
      // Extract the site from the update location
      string site = Site.CreateFromUrl(updateLocation.AbsoluteUri).Name;
      // Jiggle url
      UriBuilder jiggledUrl = new UriBuilder(url);
      jiggledUrl.Host = site;
      return jiggledUrl.ToString();
    }

    public static Uri UpdateLocation {
      get {
        // If launched via ClickOnce, return the update location
        if( ApplicationDeployment.IsNetworkDeployed ) {
          return ApplicationDeployment.CurrentDeployment.UpdateLocation;
        }
        return null;
      }
    }
  }
}
