using System;

delegate void WorkStarted();
delegate void WorkProgressing();
delegate int WorkCompleted();

//interface IWorkerEvents {
//  void WorkStarted();
//  void WorkProgressing();
//  int WorkCompleted();
//}

class Worker {
  //IWorkerEvents events;

  public event WorkStarted Started;
  public event WorkProgressing Progressing;
  public event WorkCompleted Completed;

  //public void Advise(IWorkerEvents events) {
  //  this.events = events;
  //}

  public void DoWork() {
    Console.WriteLine("Worker: work started");
    if( this.Started != null ) this.Started();

    Console.WriteLine("Worker: work progressing");
    if( this.Progressing != null ) this.Progressing();

    Console.WriteLine("Worker: work completed");
    if( this.Completed != null ) {
      foreach( WorkCompleted wc in this.Completed.GetInvocationList() ) {
        //int grade = wc();
        //wc.BeginInvoke(null, null);
        //Console.WriteLine("Worker grade=" + grade.ToString());
        //IAsyncResult result = wc.BeginInvoke(null, null);
        //while( !result.IsCompleted ) System.Threading.Thread.Sleep(1);
        //int grade = wc.EndInvoke(result);
        //Console.WriteLine("Worker grade= " + grade.ToString());
        IAsyncResult result = wc.BeginInvoke(this.WorkGraded, wc);
      }
    }
    //if( this.Completed != null ) {
    //  int grade = this.Completed();
    //  Console.WriteLine("Worker grade = " + grade.ToString());
    //}
  }
  public void WorkGraded(IAsyncResult result) {
    WorkCompleted wc = (WorkCompleted)result.AsyncState;
    int grade = wc.EndInvoke(result);
    Console.WriteLine("Worker grade= " + grade.ToString());
  }
}

class Boss { // : IWorkerEvents {

  //public void WorkStarted() {
  //  // Boss doesn't care
  //}
  //public void WorkProgressing() {
  //  // Boss doesn't care
  //}
  public int WorkCompleted() {
    //Console.WriteLine("It's about time!");
    //return 2; // out of 10

    System.Threading.Thread.Sleep(3000);
    Console.WriteLine("Better...");
    return 6; // out of 10
  }
}

class Universe {

  static void WorkerStartedWork() {
    Console.WriteLine("Universe notices worker starting work");
  }

  static int WorkerCompletedWork() {
    System.Threading.Thread.Sleep(4000);
    Console.WriteLine("Universe pleased with worker's work");
    return 7;
  }

  static void Main() {
    Worker peter = new Worker();
    Boss boss = new Boss();
    peter.Completed += boss.WorkCompleted;
    peter.Started += Universe.WorkerStartedWork;
    peter.Completed += Universe.WorkerCompletedWork;
    peter.DoWork();

    Console.WriteLine("Main: worker completed work");
    Console.ReadLine();
  }
}